clear

%% generate noisy data on two concentric spheres
D = 2;
N = 400;
K = 2;
trueLabels = [ones(N/2,1); 2*ones(N/2,1)];

var = 0.001;    % noise variance - play with this

% cluster 1
X1 = randn(D,N/2);
X1 = X1./repmat(sqrt(sum(X1.^2,1)),D,1);
X1 = X1 + repmat(sqrt(var)*randn(1,N/2),D,1);

% cluster 2
X2 = randn(D,N/2);
X2 = 2*X2./repmat(sqrt(sum(X2.^2,1)),D,1);
X2 = X2 + repmat(sqrt(var)*randn(1,N/2),D,1);

X = [X1 X2];

% look at the original data
figure
hold all
plot(X(1,trueLabels==1),X(2,trueLabels==1),'x')
plot(X(1,trueLabels==2),X(2,trueLabels==2),'x')
title('Synthetic Data - True Clusters')
title('Synthetic Data - True Clusters')

%% K-means 
estLabels = kmeans(X',2,'Replicates',100);
kmeansErr = missRate(trueLabels,estLabels)

figure
hold all
plot(X(1,estLabels==1),X(2,estLabels==1),'x')
plot(X(1,estLabels==2),X(2,estLabels==2),'x')
title('Synthetic Data - K-Means Clusters')

%% Spectral clustering
% build adjacency matrix
nNeighbors = 20;
type = 'constant';
sigma = 1;
W = myKNN(X,nNeighbors,type,sigma);

% look at the resulting graph
figure
imagesc(W)

%% apply spectral clustering
%[estLabels,Y] = mySpectralClustering(W,K,0);
%scErrUn = missRate(trueLabels,estLabels)

%[estLabels,Y] = mySpectralClustering(W,K,1);
%scErr = missRate(trueLabels,estLabels)

%% look at the data in the transformed space
%figure
%hold all
%plot(Y(1,trueLabels==1),Y(2,trueLabels==1),'x')
%plot(Y(1,trueLabels==2),Y(2,trueLabels==2),'x')
