"""
Spectral Clustering Demo - irisTest

ECE 510

python version: Python 3.7.2

Spring 2019
"""

import numpy as np
import matplotlib.pyplot as plt
from sklearn import datasets
from sklearn.cluster import KMeans
import helperFunctions as hf
from mySpectralClustering import mySpectralClustering

# load Iris dataset (common benchmark dataset)
get_Iris = datasets.load_iris()
X = get_Iris.data.T
D, N = X.shape
trueLabels = get_Iris.target.reshape(N, 1)
K = len(np.unique(trueLabels))

# Kmeans:
k_means = KMeans(n_clusters=K, max_iter=100).fit(X.T)
estLabels = k_means.labels_.reshape(N, 1)
kmeanserr, estLabels = hf.missRate(trueLabels, estLabels)
print(f"KMeans error:{kmeanserr}")

# Spectral Clustering:
nNeighbors = N - 5
wtype = 'gaussian'
sig = 0.5
W = hf.myKNN(X, nNeighbors, wtype, sigma=sig)

# # Apply Spectral Clustering
# estLabels, Y = mySpectralClustering(W, K, 0)
# scErrUn, UnestLabels_SP = hf.missRate(trueLabels, estLabels)
# print(f"Spectral Clustering error (unnormalized): {scErrUn}")

# estLabels, Y = mySpectralClustering(W, K, 1)
# scErr, estLabels_SP = hf.missRate(trueLabels, estLabels)
# print(f"Spectral Clustering error (normalized): {scErr}")
